eutils.eclass: Disable epatch_user in EAPI 6.
[gentoo.git] / eclass / eutils.eclass
1 # Copyright 1999-2015 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Id$
4
5 # @ECLASS: eutils.eclass
6 # @MAINTAINER:
7 # base-system@gentoo.org
8 # @BLURB: many extra (but common) functions that are used in ebuilds
9 # @DESCRIPTION:
10 # The eutils eclass contains a suite of functions that complement
11 # the ones that ebuild.sh already contain.  The idea is that the functions
12 # are not required in all ebuilds but enough utilize them to have a common
13 # home rather than having multiple ebuilds implementing the same thing.
14 #
15 # Due to the nature of this eclass, some functions may have maintainers
16 # different from the overall eclass!
17
18 if [[ -z ${_EUTILS_ECLASS} ]]; then
19 _EUTILS_ECLASS=1
20
21 inherit multilib toolchain-funcs
22
23 if has "${EAPI:-0}" 0 1 2; then
24
25 # @FUNCTION: epause
26 # @USAGE: [seconds]
27 # @DESCRIPTION:
28 # Sleep for the specified number of seconds (default of 5 seconds).  Useful when
29 # printing a message the user should probably be reading and often used in
30 # conjunction with the ebeep function.  If the EPAUSE_IGNORE env var is set,
31 # don't wait at all. Defined in EAPIs 0 1 and 2.
32 epause() {
33         [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34 }
35
36 # @FUNCTION: ebeep
37 # @USAGE: [number of beeps]
38 # @DESCRIPTION:
39 # Issue the specified number of beeps (default of 5 beeps).  Useful when
40 # printing a message the user should probably be reading and often used in
41 # conjunction with the epause function.  If the EBEEP_IGNORE env var is set,
42 # don't beep at all. Defined in EAPIs 0 1 and 2.
43 ebeep() {
44         local n
45         if [[ -z ${EBEEP_IGNORE} ]] ; then
46                 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47                         echo -ne "\a"
48                         sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49                         echo -ne "\a"
50                         sleep 1
51                 done
52         fi
53 }
54
55 else
56
57 ebeep() {
58         ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at https://bugs.gentoo.org"
59 }
60
61 epause() {
62         ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at https://bugs.gentoo.org"
63 }
64
65 fi
66
67 # @FUNCTION: eqawarn
68 # @USAGE: [message]
69 # @DESCRIPTION:
70 # Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71 # implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72 # profile.
73 if ! declare -F eqawarn >/dev/null ; then
74         eqawarn() {
75                 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76                 :
77         }
78 fi
79
80 # @FUNCTION: ecvs_clean
81 # @USAGE: [list of dirs]
82 # @DESCRIPTION:
83 # Remove CVS directories recursiveley.  Useful when a source tarball contains
84 # internal CVS directories.  Defaults to $PWD.
85 ecvs_clean() {
86         [[ -z $* ]] && set -- .
87         find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88         find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89 }
90
91 # @FUNCTION: esvn_clean
92 # @USAGE: [list of dirs]
93 # @DESCRIPTION:
94 # Remove .svn directories recursiveley.  Useful when a source tarball contains
95 # internal Subversion directories.  Defaults to $PWD.
96 esvn_clean() {
97         [[ -z $* ]] && set -- .
98         find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99 }
100
101 # @FUNCTION: estack_push
102 # @USAGE: <stack> [items to push]
103 # @DESCRIPTION:
104 # Push any number of items onto the specified stack.  Pick a name that
105 # is a valid variable (i.e. stick to alphanumerics), and push as many
106 # items as you like onto the stack at once.
107 #
108 # The following code snippet will echo 5, then 4, then 3, then ...
109 # @CODE
110 #               estack_push mystack 1 2 3 4 5
111 #               while estack_pop mystack i ; do
112 #                       echo "${i}"
113 #               done
114 # @CODE
115 estack_push() {
116         [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117         local stack_name="_ESTACK_$1_" ; shift
118         eval ${stack_name}+=\( \"\$@\" \)
119 }
120
121 # @FUNCTION: estack_pop
122 # @USAGE: <stack> [variable]
123 # @DESCRIPTION:
124 # Pop a single item off the specified stack.  If a variable is specified,
125 # the popped item is stored there.  If no more items are available, return
126 # 1, else return 0.  See estack_push for more info.
127 estack_pop() {
128         [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130         # We use the fugly _estack_xxx var names to avoid collision with
131         # passing back the return value.  If we used "local i" and the
132         # caller ran `estack_pop ... i`, we'd end up setting the local
133         # copy of "i" rather than the caller's copy.  The _estack_xxx
134         # garbage is preferable to using $1/$2 everywhere as that is a
135         # bit harder to read.
136         local _estack_name="_ESTACK_$1_" ; shift
137         local _estack_retvar=$1 ; shift
138         eval local _estack_i=\${#${_estack_name}\[@\]}
139         # Don't warn -- let the caller interpret this as a failure
140         # or as normal behavior (akin to `shift`)
141         [[ $(( --_estack_i )) -eq -1 ]] && return 1
142
143         if [[ -n ${_estack_retvar} ]] ; then
144                 eval ${_estack_retvar}=\"\${${_estack_name}\[${_estack_i}\]}\"
145         fi
146         eval unset ${_estack_name}\[${_estack_i}\]
147 }
148
149 # @FUNCTION: evar_push
150 # @USAGE: <variable to save> [more vars to save]
151 # @DESCRIPTION:
152 # This let's you temporarily modify a variable and then restore it (including
153 # set vs unset semantics).  Arrays are not supported at this time.
154 #
155 # This is meant for variables where using `local` does not work (such as
156 # exported variables, or only temporarily changing things in a func).
157 #
158 # For example:
159 # @CODE
160 #               evar_push LC_ALL
161 #               export LC_ALL=C
162 #               ... do some stuff that needs LC_ALL=C set ...
163 #               evar_pop
164 #
165 #               # You can also save/restore more than one var at a time
166 #               evar_push BUTTERFLY IN THE SKY
167 #               ... do stuff with the vars ...
168 #               evar_pop     # This restores just one var, SKY
169 #               ... do more stuff ...
170 #               evar_pop 3   # This pops the remaining 3 vars
171 # @CODE
172 evar_push() {
173         local var val
174         for var ; do
175                 [[ ${!var+set} == "set" ]] \
176                         && val=${!var} \
177                         || val="unset_76fc3c462065bb4ca959f939e6793f94"
178                 estack_push evar "${var}" "${val}"
179         done
180 }
181
182 # @FUNCTION: evar_push_set
183 # @USAGE: <variable to save> [new value to store]
184 # @DESCRIPTION:
185 # This is a handy shortcut to save and temporarily set a variable.  If a value
186 # is not specified, the var will be unset.
187 evar_push_set() {
188         local var=$1
189         evar_push ${var}
190         case $# in
191         1) unset ${var} ;;
192         2) printf -v "${var}" '%s' "$2" ;;
193         *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194         esac
195 }
196
197 # @FUNCTION: evar_pop
198 # @USAGE: [number of vars to restore]
199 # @DESCRIPTION:
200 # Restore the variables to the state saved with the corresponding
201 # evar_push call.  See that function for more details.
202 evar_pop() {
203         local cnt=${1:-bad}
204         case $# in
205         0) cnt=1 ;;
206         1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207         *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208         esac
209
210         local var val
211         while (( cnt-- )) ; do
212                 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213                 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214                 [[ ${val} == "unset_76fc3c462065bb4ca959f939e6793f94" ]] \
215                         && unset ${var} \
216                         || printf -v "${var}" '%s' "${val}"
217         done
218 }
219
220 # @FUNCTION: eshopts_push
221 # @USAGE: [options to `set` or `shopt`]
222 # @DESCRIPTION:
223 # Often times code will want to enable a shell option to change code behavior.
224 # Since changing shell options can easily break other pieces of code (which
225 # assume the default state), eshopts_push is used to (1) push the current shell
226 # options onto a stack and (2) pass the specified arguments to set.
227 #
228 # If the first argument is '-s' or '-u', we assume you want to call `shopt`
229 # rather than `set` as there are some options only available via that.
230 #
231 # A common example is to disable shell globbing so that special meaning/care
232 # may be used with variables/arguments to custom functions.  That would be:
233 # @CODE
234 #               eshopts_push -o noglob
235 #               for x in ${foo} ; do
236 #                       if ...some check... ; then
237 #                               eshopts_pop
238 #                               return 0
239 #                       fi
240 #               done
241 #               eshopts_pop
242 # @CODE
243 eshopts_push() {
244         if [[ $1 == -[su] ]] ; then
245                 estack_push eshopts "$(shopt -p)"
246                 [[ $# -eq 0 ]] && return 0
247                 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248         else
249                 estack_push eshopts $-
250                 [[ $# -eq 0 ]] && return 0
251                 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252         fi
253 }
254
255 # @FUNCTION: eshopts_pop
256 # @USAGE:
257 # @DESCRIPTION:
258 # Restore the shell options to the state saved with the corresponding
259 # eshopts_push call.  See that function for more details.
260 eshopts_pop() {
261         local s
262         estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263         if [[ ${s} == "shopt -"* ]] ; then
264                 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265         else
266                 set +$-     || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267                 set -${s}   || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268         fi
269 }
270
271 # @FUNCTION: eumask_push
272 # @USAGE: <new umask>
273 # @DESCRIPTION:
274 # Set the umask to the new value specified while saving the previous
275 # value onto a stack.  Useful for temporarily changing the umask.
276 eumask_push() {
277         estack_push eumask "$(umask)"
278         umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279 }
280
281 # @FUNCTION: eumask_pop
282 # @USAGE:
283 # @DESCRIPTION:
284 # Restore the previous umask state.
285 eumask_pop() {
286         [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287         local s
288         estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289         umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290 }
291
292 # @FUNCTION: isdigit
293 # @USAGE: <number> [more numbers]
294 # @DESCRIPTION:
295 # Return true if all arguments are numbers.
296 isdigit() {
297         local d
298         for d ; do
299                 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300         done
301         return 0
302 }
303
304 # @VARIABLE: EPATCH_SOURCE
305 # @DESCRIPTION:
306 # Default directory to search for patches.
307 EPATCH_SOURCE="${WORKDIR}/patch"
308 # @VARIABLE: EPATCH_SUFFIX
309 # @DESCRIPTION:
310 # Default extension for patches (do not prefix the period yourself).
311 EPATCH_SUFFIX="patch.bz2"
312 # @VARIABLE: EPATCH_OPTS
313 # @DESCRIPTION:
314 # Options to pass to patch.  Meant for ebuild/package-specific tweaking
315 # such as forcing the patch level (-p#) or fuzz (-F#) factor.  Note that
316 # for single patch tweaking, you can also pass flags directly to epatch.
317 EPATCH_OPTS=""
318 # @VARIABLE: EPATCH_COMMON_OPTS
319 # @DESCRIPTION:
320 # Common options to pass to `patch`.  You probably should never need to
321 # change these.  If you do, please discuss it with base-system first to
322 # be sure.
323 # @CODE
324 #       -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325 #       --no-backup-if-mismatch - do not leave .orig files behind
326 #       -E - automatically remove empty files
327 # @CODE
328 EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329 # @VARIABLE: EPATCH_EXCLUDE
330 # @DESCRIPTION:
331 # List of patches not to apply.  Note this is only file names,
332 # and not the full path.  Globs accepted.
333 EPATCH_EXCLUDE=""
334 # @VARIABLE: EPATCH_SINGLE_MSG
335 # @DESCRIPTION:
336 # Change the printed message for a single patch.
337 EPATCH_SINGLE_MSG=""
338 # @VARIABLE: EPATCH_MULTI_MSG
339 # @DESCRIPTION:
340 # Change the printed message for multiple patches.
341 EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342 # @VARIABLE: EPATCH_FORCE
343 # @DESCRIPTION:
344 # Only require patches to match EPATCH_SUFFIX rather than the extended
345 # arch naming style.
346 EPATCH_FORCE="no"
347 # @VARIABLE: EPATCH_USER_EXCLUDE
348 # @DEFAULT_UNSET
349 # @DESCRIPTION:
350 # List of patches not to apply.  Note this is only file names,
351 # and not the full path.  Globs accepted.
352
353 # @FUNCTION: epatch
354 # @USAGE: [options] [patches] [dirs of patches]
355 # @DESCRIPTION:
356 # epatch is designed to greatly simplify the application of patches.  It can
357 # process patch files directly, or directories of patches.  The patches may be
358 # compressed (bzip/gzip/etc...) or plain text.  You generally need not specify
359 # the -p option as epatch will automatically attempt -p0 to -p4 until things
360 # apply successfully.
361 #
362 # If you do not specify any patches/dirs, then epatch will default to the
363 # directory specified by EPATCH_SOURCE.
364 #
365 # Any options specified that start with a dash will be passed down to patch
366 # for this specific invocation.  As soon as an arg w/out a dash is found, then
367 # arg processing stops.
368 #
369 # When processing directories, epatch will apply all patches that match:
370 # @CODE
371 #       if ${EPATCH_FORCE} != "yes"
372 #               ??_${ARCH}_foo.${EPATCH_SUFFIX}
373 #       else
374 #               *.${EPATCH_SUFFIX}
375 # @CODE
376 # The leading ?? are typically numbers used to force consistent patch ordering.
377 # The arch field is used to apply patches only for the host architecture with
378 # the special value of "all" means apply for everyone.  Note that using values
379 # other than "all" is highly discouraged -- you should apply patches all the
380 # time and let architecture details be detected at configure/compile time.
381 #
382 # If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383 # for patches to apply.
384 #
385 # Refer to the other EPATCH_xxx variables for more customization of behavior.
386 epatch() {
387         _epatch_draw_line() {
388                 # create a line of same length as input string
389                 [[ -z $1 ]] && set "$(printf "%65s" '')"
390                 echo "${1//?/=}"
391         }
392
393         unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
394
395         # First process options.  We localize the EPATCH_OPTS setting
396         # from above so that we can pass it on in the loop below with
397         # any additional values the user has specified.
398         local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399         while [[ $# -gt 0 ]] ; do
400                 case $1 in
401                 -*) EPATCH_OPTS+=( "$1" ) ;;
402                 *) break ;;
403                 esac
404                 shift
405         done
406
407         # Let the rest of the code process one user arg at a time --
408         # each arg may expand into multiple patches, and each arg may
409         # need to start off with the default global EPATCH_xxx values
410         if [[ $# -gt 1 ]] ; then
411                 local m
412                 for m in "$@" ; do
413                         epatch "${m}"
414                 done
415                 return 0
416         fi
417
418         local SINGLE_PATCH="no"
419         # no args means process ${EPATCH_SOURCE}
420         [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
421
422         if [[ -f $1 ]] ; then
423                 SINGLE_PATCH="yes"
424                 set -- "$1"
425                 # Use the suffix from the single patch (localize it); the code
426                 # below will find the suffix for us
427                 local EPATCH_SUFFIX=$1
428
429         elif [[ -d $1 ]] ; then
430                 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
431                 evar_push_set LC_COLLATE C
432                 # Some people like to make dirs of patches w/out suffixes (vim).
433                 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434                 evar_pop
435
436         elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437                 # Re-use EPATCH_SOURCE as a search dir
438                 epatch "${EPATCH_SOURCE}/$1"
439                 return $?
440
441         else
442                 # sanity check ... if it isn't a dir or file, wtf man ?
443                 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444                 echo
445                 eerror "Cannot find \$EPATCH_SOURCE!  Value for \$EPATCH_SOURCE is:"
446                 eerror
447                 eerror "  ${EPATCH_SOURCE}"
448                 eerror "  ( ${EPATCH_SOURCE##*/} )"
449                 echo
450                 die "Cannot find \$EPATCH_SOURCE!"
451         fi
452
453         # Now that we know we're actually going to apply something, merge
454         # all of the patch options back in to a single variable for below.
455         EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
457         local PIPE_CMD
458         case ${EPATCH_SUFFIX##*\.} in
459                 xz)      PIPE_CMD="xz -dc"    ;;
460                 lzma)    PIPE_CMD="lzma -dc"  ;;
461                 bz2)     PIPE_CMD="bzip2 -dc" ;;
462                 gz|Z|z)  PIPE_CMD="gzip -dc"  ;;
463                 ZIP|zip) PIPE_CMD="unzip -p"  ;;
464                 *)       ;;
465         esac
466
467         [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468
469         local x
470         for x in "$@" ; do
471                 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472                 # didn't match anything, ignore continue on
473                 [[ ! -f ${x} ]] && continue
474
475                 local patchname=${x##*/}
476
477                 # Apply single patches, or forced sets of patches, or
478                 # patches with ARCH dependant names.
479                 #       ???_arch_foo.patch
480                 # Else, skip this input altogether
481                 local a=${patchname#*_} # strip the ???_
482                 a=${a%%_*}              # strip the _foo.patch
483                 if ! [[ ${SINGLE_PATCH} == "yes" || \
484                                 ${EPATCH_FORCE} == "yes" || \
485                                 ${a} == all     || \
486                                 ${a} == ${ARCH} ]]
487                 then
488                         continue
489                 fi
490
491                 # Let people filter things dynamically
492                 if [[ -n ${EPATCH_EXCLUDE}${EPATCH_USER_EXCLUDE} ]] ; then
493                         # let people use globs in the exclude
494                         eshopts_push -o noglob
495
496                         local ex
497                         for ex in ${EPATCH_EXCLUDE} ; do
498                                 if [[ ${patchname} == ${ex} ]] ; then
499                                         einfo "  Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500                                         eshopts_pop
501                                         continue 2
502                                 fi
503                         done
504
505                         for ex in ${EPATCH_USER_EXCLUDE} ; do
506                                 if [[ ${patchname} == ${ex} ]] ; then
507                                         einfo "  Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508                                         eshopts_pop
509                                         continue 2
510                                 fi
511                         done
512
513                         eshopts_pop
514                 fi
515
516                 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517                         if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518                                 einfo "${EPATCH_SINGLE_MSG}"
519                         else
520                                 einfo "Applying ${patchname} ..."
521                         fi
522                 else
523                         einfo "  ${patchname} ..."
524                 fi
525
526                 # Handle aliased patch command #404447 #461568
527                 local patch="patch"
528                 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
529
530                 # most of the time, there will only be one run per unique name,
531                 # but if there are more, make sure we get unique log filenames
532                 local STDERR_TARGET="${T}/${patchname}.out"
533                 if [[ -e ${STDERR_TARGET} ]] ; then
534                         STDERR_TARGET="${T}/${patchname}-$$.out"
535                 fi
536
537                 printf "***** %s *****\nPWD: %s\nPATCH TOOL: %s -> %s\nVERSION INFO:\n%s\n\n" \
538                         "${patchname}" \
539                         "${PWD}" \
540                         "${patch}" \
541                         "$(type -P "${patch}")" \
542                         "$(${patch} --version)" \
543                         > "${STDERR_TARGET}"
544
545                 # Decompress the patch if need be
546                 local count=0
547                 local PATCH_TARGET
548                 if [[ -n ${PIPE_CMD} ]] ; then
549                         PATCH_TARGET="${T}/$$.patch"
550                         echo "PIPE_COMMAND:  ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
551
552                         if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
553                                 echo
554                                 eerror "Could not extract patch!"
555                                 #die "Could not extract patch!"
556                                 count=5
557                                 break
558                         fi
559                 else
560                         PATCH_TARGET=${x}
561                 fi
562
563                 # Check for absolute paths in patches.  If sandbox is disabled,
564                 # people could (accidently) patch files in the root filesystem.
565                 # Or trigger other unpleasantries #237667.  So disallow -p0 on
566                 # such patches.
567                 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
568                 if [[ -n ${abs_paths} ]] ; then
569                         count=1
570                         printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
571                 fi
572                 # Similar reason, but with relative paths.
573                 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
574                 if [[ -n ${rel_paths} ]] ; then
575                         echo
576                         eerror "Rejected Patch: ${patchname} !"
577                         eerror " ( ${PATCH_TARGET} )"
578                         eerror
579                         eerror "Your patch uses relative paths '../':"
580                         eerror "${rel_paths}"
581                         echo
582                         die "you need to fix the relative paths in patch"
583                 fi
584
585                 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
586                 local patch_cmd
587                 while [[ ${count} -lt 5 ]] ; do
588                         patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
589
590                         # Generate some useful debug info ...
591                         (
592                         _epatch_draw_line "***** ${patchname} *****"
593                         echo
594                         echo "PATCH COMMAND:  ${patch_cmd} --dry-run -f < '${PATCH_TARGET}'"
595                         echo
596                         _epatch_draw_line "***** ${patchname} *****"
597                         ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
598                         ret=$?
599                         echo
600                         echo "patch program exited with status ${ret}"
601                         exit ${ret}
602                         ) >> "${STDERR_TARGET}"
603
604                         if [ $? -eq 0 ] ; then
605                                 (
606                                 _epatch_draw_line "***** ${patchname} *****"
607                                 echo
608                                 echo "ACTUALLY APPLYING ${patchname} ..."
609                                 echo "PATCH COMMAND:  ${patch_cmd} < '${PATCH_TARGET}'"
610                                 echo
611                                 _epatch_draw_line "***** ${patchname} *****"
612                                 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
613                                 ret=$?
614                                 echo
615                                 echo "patch program exited with status ${ret}"
616                                 exit ${ret}
617                                 ) >> "${STDERR_TARGET}"
618
619                                 if [ $? -ne 0 ] ; then
620                                         echo
621                                         eerror "A dry-run of patch command succeeded, but actually"
622                                         eerror "applying the patch failed!"
623                                         #die "Real world sux compared to the dreamworld!"
624                                         count=5
625                                 fi
626                                 break
627                         fi
628
629                         : $(( count++ ))
630                 done
631
632                 # if we had to decompress the patch, delete the temp one
633                 if [[ -n ${PIPE_CMD} ]] ; then
634                         rm -f "${PATCH_TARGET}"
635                 fi
636
637                 if [[ ${count} -ge 5 ]] ; then
638                         echo
639                         eerror "Failed Patch: ${patchname} !"
640                         eerror " ( ${PATCH_TARGET} )"
641                         eerror
642                         eerror "Include in your bugreport the contents of:"
643                         eerror
644                         eerror "  ${STDERR_TARGET}"
645                         echo
646                         die "Failed Patch: ${patchname}!"
647                 fi
648
649                 # if everything worked, delete the full debug patch log
650                 rm -f "${STDERR_TARGET}"
651
652                 # then log away the exact stuff for people to review later
653                 cat <<-EOF >> "${T}/epatch.log"
654                 PATCH: ${x}
655                 CMD: ${patch_cmd}
656                 PWD: ${PWD}
657
658                 EOF
659                 eend 0
660         done
661
662         [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
663         : # everything worked
664 }
665
666 if has "${EAPI:-0}" 0 1 2 3 4 5; then
667 # @VARIABLE: EPATCH_USER_SOURCE
668 # @DESCRIPTION:
669 # Location for user patches, see the epatch_user function.
670 # Should be set by the user. Don't set this in ebuilds.
671 : ${EPATCH_USER_SOURCE:=${PORTAGE_CONFIGROOT%/}/etc/portage/patches}
672
673 # @FUNCTION: epatch_user
674 # @USAGE:
675 # @DESCRIPTION:
676 # Applies user-provided patches to the source tree. The patches are
677 # taken from /etc/portage/patches/<CATEGORY>/<P-PR|P|PN>[:SLOT]/, where the first
678 # of these three directories to exist will be the one to use, ignoring
679 # any more general directories which might exist as well. They must end
680 # in ".patch" to be applied.
681 #
682 # User patches are intended for quick testing of patches without ebuild
683 # modifications, as well as for permanent customizations a user might
684 # desire. Obviously, there can be no official support for arbitrarily
685 # patched ebuilds. So whenever a build log in a bug report mentions that
686 # user patches were applied, the user should be asked to reproduce the
687 # problem without these.
688 #
689 # Not all ebuilds do call this function, so placing patches in the
690 # stated directory might or might not work, depending on the package and
691 # the eclasses it inherits and uses. It is safe to call the function
692 # repeatedly, so it is always possible to add a call at the ebuild
693 # level. The first call is the time when the patches will be
694 # applied.
695 #
696 # Ideally, this function should be called after gentoo-specific patches
697 # have been applied, so that their code can be modified as well, but
698 # before calls to e.g. eautoreconf, as the user patches might affect
699 # autotool input files as well.
700 epatch_user() {
701         [[ $# -ne 0 ]] && die "epatch_user takes no options"
702
703         # Allow multiple calls to this function; ignore all but the first
704         local applied="${T}/epatch_user.log"
705         [[ -e ${applied} ]] && return 2
706
707         # don't clobber any EPATCH vars that the parent might want
708         local EPATCH_SOURCE check
709         for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
710                 EPATCH_SOURCE=${EPATCH_USER_SOURCE}/${CTARGET}/${check}
711                 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${EPATCH_USER_SOURCE}/${CHOST}/${check}
712                 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${EPATCH_USER_SOURCE}/${check}
713                 if [[ -d ${EPATCH_SOURCE} ]] ; then
714                         EPATCH_SOURCE=${EPATCH_SOURCE} \
715                         EPATCH_SUFFIX="patch" \
716                         EPATCH_FORCE="yes" \
717                         EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
718                         epatch
719                         echo "${EPATCH_SOURCE}" > "${applied}"
720                         has epatch_user_death_notice ${EBUILD_DEATH_HOOKS} || EBUILD_DEATH_HOOKS+=" epatch_user_death_notice"
721                         return 0
722                 fi
723         done
724         echo "none" > "${applied}"
725         return 1
726 }
727 # @FUNCTION: epatch_user_death_notice
728 # @INTERNAL
729 # @DESCRIPTION:
730 # Include an explicit notice in the die message itself that user patches were
731 # applied to this build.
732 epatch_user_death_notice() {
733         ewarn "!!! User patches were applied to this build!"
734 }
735 fi
736
737 # @FUNCTION: emktemp
738 # @USAGE: [temp dir]
739 # @DESCRIPTION:
740 # Cheap replacement for when debianutils (and thus mktemp)
741 # does not exist on the users system.
742 emktemp() {
743         local exe="touch"
744         [[ $1 == -d ]] && exe="mkdir" && shift
745         local topdir=$1
746
747         if [[ -z ${topdir} ]] ; then
748                 [[ -z ${T} ]] \
749                         && topdir="/tmp" \
750                         || topdir=${T}
751         fi
752
753         if ! type -P mktemp > /dev/null ; then
754                 # system lacks `mktemp` so we have to fake it
755                 local tmp=/
756                 while [[ -e ${tmp} ]] ; do
757                         tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
758                 done
759                 ${exe} "${tmp}" || ${exe} -p "${tmp}"
760                 echo "${tmp}"
761         else
762                 # the args here will give slightly wierd names on BSD,
763                 # but should produce a usable file on all userlands
764                 if [[ ${exe} == "touch" ]] ; then
765                         TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
766                 else
767                         TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
768                 fi
769         fi
770 }
771
772 # @FUNCTION: edos2unix
773 # @USAGE: <file> [more files ...]
774 # @DESCRIPTION:
775 # A handy replacement for dos2unix, recode, fixdos, etc...  This allows you
776 # to remove all of these text utilities from DEPEND variables because this
777 # is a script based solution.  Just give it a list of files to convert and
778 # they will all be changed from the DOS CRLF format to the UNIX LF format.
779 edos2unix() {
780         [[ $# -eq 0 ]] && return 0
781         sed -i 's/\r$//' -- "$@" || die
782 }
783
784 # @FUNCTION: make_desktop_entry
785 # @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
786 # @DESCRIPTION:
787 # Make a .desktop file.
788 #
789 # @CODE
790 # binary:   what command does the app run with ?
791 # name:     the name that will show up in the menu
792 # icon:     the icon to use in the menu entry
793 #           this can be relative (to /usr/share/pixmaps) or
794 #           a full path to an icon
795 # type:     what kind of application is this?
796 #           for categories:
797 #           http://standards.freedesktop.org/menu-spec/latest/apa.html
798 #           if unset, function tries to guess from package's category
799 # fields:       extra fields to append to the desktop file; a printf string
800 # @CODE
801 make_desktop_entry() {
802         [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
803
804         local exec=${1}
805         local name=${2:-${PN}}
806         local icon=${3:-${PN}}
807         local type=${4}
808         local fields=${5}
809
810         if [[ -z ${type} ]] ; then
811                 local catmaj=${CATEGORY%%-*}
812                 local catmin=${CATEGORY##*-}
813                 case ${catmaj} in
814                         app)
815                                 case ${catmin} in
816                                         accessibility) type="Utility;Accessibility";;
817                                         admin)         type=System;;
818                                         antivirus)     type=System;;
819                                         arch)          type="Utility;Archiving";;
820                                         backup)        type="Utility;Archiving";;
821                                         cdr)           type="AudioVideo;DiscBurning";;
822                                         dicts)         type="Office;Dictionary";;
823                                         doc)           type=Documentation;;
824                                         editors)       type="Utility;TextEditor";;
825                                         emacs)         type="Development;TextEditor";;
826                                         emulation)     type="System;Emulator";;
827                                         laptop)        type="Settings;HardwareSettings";;
828                                         office)        type=Office;;
829                                         pda)           type="Office;PDA";;
830                                         vim)           type="Development;TextEditor";;
831                                         xemacs)        type="Development;TextEditor";;
832                                 esac
833                                 ;;
834
835                         dev)
836                                 type="Development"
837                                 ;;
838
839                         games)
840                                 case ${catmin} in
841                                         action|fps) type=ActionGame;;
842                                         arcade)     type=ArcadeGame;;
843                                         board)      type=BoardGame;;
844                                         emulation)  type=Emulator;;
845                                         kids)       type=KidsGame;;
846                                         puzzle)     type=LogicGame;;
847                                         roguelike)  type=RolePlaying;;
848                                         rpg)        type=RolePlaying;;
849                                         simulation) type=Simulation;;
850                                         sports)     type=SportsGame;;
851                                         strategy)   type=StrategyGame;;
852                                 esac
853                                 type="Game;${type}"
854                                 ;;
855
856                         gnome)
857                                 type="Gnome;GTK"
858                                 ;;
859
860                         kde)
861                                 type="KDE;Qt"
862                                 ;;
863
864                         mail)
865                                 type="Network;Email"
866                                 ;;
867
868                         media)
869                                 case ${catmin} in
870                                         gfx)
871                                                 type=Graphics
872                                                 ;;
873                                         *)
874                                                 case ${catmin} in
875                                                         radio) type=Tuner;;
876                                                         sound) type=Audio;;
877                                                         tv)    type=TV;;
878                                                         video) type=Video;;
879                                                 esac
880                                                 type="AudioVideo;${type}"
881                                                 ;;
882                                 esac
883                                 ;;
884
885                         net)
886                                 case ${catmin} in
887                                         dialup) type=Dialup;;
888                                         ftp)    type=FileTransfer;;
889                                         im)     type=InstantMessaging;;
890                                         irc)    type=IRCClient;;
891                                         mail)   type=Email;;
892                                         news)   type=News;;
893                                         nntp)   type=News;;
894                                         p2p)    type=FileTransfer;;
895                                         voip)   type=Telephony;;
896                                 esac
897                                 type="Network;${type}"
898                                 ;;
899
900                         sci)
901                                 case ${catmin} in
902                                         astro*)  type=Astronomy;;
903                                         bio*)    type=Biology;;
904                                         calc*)   type=Calculator;;
905                                         chem*)   type=Chemistry;;
906                                         elec*)   type=Electronics;;
907                                         geo*)    type=Geology;;
908                                         math*)   type=Math;;
909                                         physics) type=Physics;;
910                                         visual*) type=DataVisualization;;
911                                 esac
912                                 type="Education;Science;${type}"
913                                 ;;
914
915                         sys)
916                                 type="System"
917                                 ;;
918
919                         www)
920                                 case ${catmin} in
921                                         client) type=WebBrowser;;
922                                 esac
923                                 type="Network;${type}"
924                                 ;;
925
926                         *)
927                                 type=
928                                 ;;
929                 esac
930         fi
931         local slot=${SLOT%/*}
932         if [[ ${slot} == "0" ]] ; then
933                 local desktop_name="${PN}"
934         else
935                 local desktop_name="${PN}-${slot}"
936         fi
937         local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
938         #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
939
940         # Don't append another ";" when a valid category value is provided.
941         type=${type%;}${type:+;}
942
943         eshopts_push -s extglob
944         if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
945                 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
946                 ewarn "allowed in .desktop files if the value is not an absolute path."
947                 icon=${icon%.@(xpm|png|svg)}
948         fi
949         eshopts_pop
950
951         cat <<-EOF > "${desktop}"
952         [Desktop Entry]
953         Name=${name}
954         Type=Application
955         Comment=${DESCRIPTION}
956         Exec=${exec}
957         TryExec=${exec%% *}
958         Icon=${icon}
959         Categories=${type}
960         EOF
961
962         if [[ ${fields:-=} != *=* ]] ; then
963                 # 5th arg used to be value to Path=
964                 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
965                 fields="Path=${fields}"
966         fi
967         [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
968
969         (
970                 # wrap the env here so that the 'insinto' call
971                 # doesn't corrupt the env of the caller
972                 insinto /usr/share/applications
973                 doins "${desktop}"
974         ) || die "installing desktop file failed"
975 }
976
977 # @FUNCTION: _eutils_eprefix_init
978 # @INTERNAL
979 # @DESCRIPTION:
980 # Initialized prefix variables for EAPI<3.
981 _eutils_eprefix_init() {
982         has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
983 }
984
985 # @FUNCTION: validate_desktop_entries
986 # @USAGE: [directories]
987 # @MAINTAINER:
988 # Carsten Lohrke <carlo@gentoo.org>
989 # @DESCRIPTION:
990 # Validate desktop entries using desktop-file-utils
991 validate_desktop_entries() {
992         _eutils_eprefix_init
993         if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
994                 einfo "Checking desktop entry validity"
995                 local directories=""
996                 for d in /usr/share/applications $@ ; do
997                         [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
998                 done
999                 if [[ -n ${directories} ]] ; then
1000                         for FILE in $(find ${directories} -name "*\.desktop" \
1001                                                         -not -path '*.hidden*' | sort -u 2>/dev/null)
1002                         do
1003                                 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
1004                                                                 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
1005                                 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
1006                         done
1007                 fi
1008                 echo ""
1009         else
1010                 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
1011         fi
1012 }
1013
1014 # @FUNCTION: make_session_desktop
1015 # @USAGE: <title> <command> [command args...]
1016 # @DESCRIPTION:
1017 # Make a GDM/KDM Session file.  The title is the file to execute to start the
1018 # Window Manager.  The command is the name of the Window Manager.
1019 #
1020 # You can set the name of the file via the ${wm} variable.
1021 make_session_desktop() {
1022         [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
1023         [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
1024
1025         local title=$1
1026         local command=$2
1027         local desktop=${T}/${wm:-${PN}}.desktop
1028         shift 2
1029
1030         cat <<-EOF > "${desktop}"
1031         [Desktop Entry]
1032         Name=${title}
1033         Comment=This session logs you into ${title}
1034         Exec=${command} $*
1035         TryExec=${command}
1036         Type=XSession
1037         EOF
1038
1039         (
1040         # wrap the env here so that the 'insinto' call
1041         # doesn't corrupt the env of the caller
1042         insinto /usr/share/xsessions
1043         doins "${desktop}"
1044         )
1045 }
1046
1047 # @FUNCTION: domenu
1048 # @USAGE: <menus>
1049 # @DESCRIPTION:
1050 # Install the list of .desktop menu files into the appropriate directory
1051 # (/usr/share/applications).
1052 domenu() {
1053         (
1054         # wrap the env here so that the 'insinto' call
1055         # doesn't corrupt the env of the caller
1056         local i j ret=0
1057         insinto /usr/share/applications
1058         for i in "$@" ; do
1059                 if [[ -f ${i} ]] ; then
1060                         doins "${i}"
1061                         ((ret+=$?))
1062                 elif [[ -d ${i} ]] ; then
1063                         for j in "${i}"/*.desktop ; do
1064                                 doins "${j}"
1065                                 ((ret+=$?))
1066                         done
1067                 else
1068                         ((++ret))
1069                 fi
1070         done
1071         exit ${ret}
1072         )
1073 }
1074
1075 # @FUNCTION: newmenu
1076 # @USAGE: <menu> <newname>
1077 # @DESCRIPTION:
1078 # Like all other new* functions, install the specified menu as newname.
1079 newmenu() {
1080         (
1081         # wrap the env here so that the 'insinto' call
1082         # doesn't corrupt the env of the caller
1083         insinto /usr/share/applications
1084         newins "$@"
1085         )
1086 }
1087
1088 # @FUNCTION: _iconins
1089 # @INTERNAL
1090 # @DESCRIPTION:
1091 # function for use in doicon and newicon
1092 _iconins() {
1093         (
1094         # wrap the env here so that the 'insinto' call
1095         # doesn't corrupt the env of the caller
1096         local funcname=$1; shift
1097         local size dir
1098         local context=apps
1099         local theme=hicolor
1100
1101         while [[ $# -gt 0 ]] ; do
1102                 case $1 in
1103                 -s|--size)
1104                         if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1105                                 size=${2%%x*}
1106                         else
1107                                 size=${2}
1108                         fi
1109                         case ${size} in
1110                         16|22|24|32|36|48|64|72|96|128|192|256|512)
1111                                 size=${size}x${size};;
1112                         scalable)
1113                                 ;;
1114                         *)
1115                                 eerror "${size} is an unsupported icon size!"
1116                                 exit 1;;
1117                         esac
1118                         shift 2;;
1119                 -t|--theme)
1120                         theme=${2}
1121                         shift 2;;
1122                 -c|--context)
1123                         context=${2}
1124                         shift 2;;
1125                 *)
1126                         if [[ -z ${size} ]] ; then
1127                                 insinto /usr/share/pixmaps
1128                         else
1129                                 insinto /usr/share/icons/${theme}/${size}/${context}
1130                         fi
1131
1132                         if [[ ${funcname} == doicon ]] ; then
1133                                 if [[ -f $1 ]] ; then
1134                                         doins "${1}"
1135                                 elif [[ -d $1 ]] ; then
1136                                         shopt -s nullglob
1137                                         doins "${1}"/*.{png,svg}
1138                                         shopt -u nullglob
1139                                 else
1140                                         eerror "${1} is not a valid file/directory!"
1141                                         exit 1
1142                                 fi
1143                         else
1144                                 break
1145                         fi
1146                         shift 1;;
1147                 esac
1148         done
1149         if [[ ${funcname} == newicon ]] ; then
1150                 newins "$@"
1151         fi
1152         ) || die
1153 }
1154
1155 # @FUNCTION: doicon
1156 # @USAGE: [options] <icons>
1157 # @DESCRIPTION:
1158 # Install icon into the icon directory /usr/share/icons or into
1159 # /usr/share/pixmaps if "--size" is not set.
1160 # This is useful in conjunction with creating desktop/menu files.
1161 #
1162 # @CODE
1163 #  options:
1164 #  -s, --size
1165 #    !!! must specify to install into /usr/share/icons/... !!!
1166 #    size of the icon, like 48 or 48x48
1167 #    supported icon sizes are:
1168 #    16 22 24 32 36 48 64 72 96 128 192 256 scalable
1169 #  -c, --context
1170 #    defaults to "apps"
1171 #  -t, --theme
1172 #    defaults to "hicolor"
1173 #
1174 # icons: list of icons
1175 #
1176 # example 1: doicon foobar.png fuqbar.svg suckbar.png
1177 # results in: insinto /usr/share/pixmaps
1178 #             doins foobar.png fuqbar.svg suckbar.png
1179 #
1180 # example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
1181 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1182 #             doins foobar.png fuqbar.png blobbar.png
1183 # @CODE
1184 doicon() {
1185         _iconins ${FUNCNAME} "$@"
1186 }
1187
1188 # @FUNCTION: newicon
1189 # @USAGE: [options] <icon> <newname>
1190 # @DESCRIPTION:
1191 # Like doicon, install the specified icon as newname.
1192 #
1193 # @CODE
1194 # example 1: newicon foobar.png NEWNAME.png
1195 # results in: insinto /usr/share/pixmaps
1196 #             newins foobar.png NEWNAME.png
1197 #
1198 # example 2: newicon -s 48 foobar.png NEWNAME.png
1199 # results in: insinto /usr/share/icons/hicolor/48x48/apps
1200 #             newins foobar.png NEWNAME.png
1201 # @CODE
1202 newicon() {
1203         _iconins ${FUNCNAME} "$@"
1204 }
1205
1206 # @FUNCTION: strip-linguas
1207 # @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
1208 # @DESCRIPTION:
1209 # Make sure that LINGUAS only contains languages that
1210 # a package can support.  The first form allows you to
1211 # specify a list of LINGUAS.  The -i builds a list of po
1212 # files found in all the directories and uses the
1213 # intersection of the lists.  The -u builds a list of po
1214 # files found in all the directories and uses the union
1215 # of the lists.
1216 strip-linguas() {
1217         local ls newls nols
1218         if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1219                 local op=$1; shift
1220                 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1221                 local d f
1222                 for d in "$@" ; do
1223                         if [[ ${op} == "-u" ]] ; then
1224                                 newls=${ls}
1225                         else
1226                                 newls=""
1227                         fi
1228                         for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1229                                 if [[ ${op} == "-i" ]] ; then
1230                                         has ${f} ${ls} && newls="${newls} ${f}"
1231                                 else
1232                                         has ${f} ${ls} || newls="${newls} ${f}"
1233                                 fi
1234                         done
1235                         ls=${newls}
1236                 done
1237         else
1238                 ls="$@"
1239         fi
1240
1241         nols=""
1242         newls=""
1243         for f in ${LINGUAS} ; do
1244                 if has ${f} ${ls} ; then
1245                         newls="${newls} ${f}"
1246                 else
1247                         nols="${nols} ${f}"
1248                 fi
1249         done
1250         [[ -n ${nols} ]] \
1251                 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1252         export LINGUAS=${newls:1}
1253 }
1254
1255 # @FUNCTION: preserve_old_lib
1256 # @USAGE: <libs to preserve> [more libs]
1257 # @DESCRIPTION:
1258 # These functions are useful when a lib in your package changes ABI SONAME.
1259 # An example might be from libogg.so.0 to libogg.so.1.  Removing libogg.so.0
1260 # would break packages that link against it.  Most people get around this
1261 # by using the portage SLOT mechanism, but that is not always a relevant
1262 # solution, so instead you can call this from pkg_preinst.  See also the
1263 # preserve_old_lib_notify function.
1264 preserve_old_lib() {
1265         _eutils_eprefix_init
1266         if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1267                 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1268                 die "Invalid preserve_old_lib() usage"
1269         fi
1270         [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1271
1272         # let portage worry about it
1273         has preserve-libs ${FEATURES} && return 0
1274
1275         local lib dir
1276         for lib in "$@" ; do
1277                 [[ -e ${EROOT}/${lib} ]] || continue
1278                 dir=${lib%/*}
1279                 dodir ${dir} || die "dodir ${dir} failed"
1280                 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1281                 touch "${ED}"/${lib}
1282         done
1283 }
1284
1285 # @FUNCTION: preserve_old_lib_notify
1286 # @USAGE: <libs to notify> [more libs]
1287 # @DESCRIPTION:
1288 # Spit helpful messages about the libraries preserved by preserve_old_lib.
1289 preserve_old_lib_notify() {
1290         if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1291                 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1292                 die "Invalid preserve_old_lib_notify() usage"
1293         fi
1294
1295         # let portage worry about it
1296         has preserve-libs ${FEATURES} && return 0
1297
1298         _eutils_eprefix_init
1299
1300         local lib notice=0
1301         for lib in "$@" ; do
1302                 [[ -e ${EROOT}/${lib} ]] || continue
1303                 if [[ ${notice} -eq 0 ]] ; then
1304                         notice=1
1305                         ewarn "Old versions of installed libraries were detected on your system."
1306                         ewarn "In order to avoid breaking packages that depend on these old libs,"
1307                         ewarn "the libraries are not being removed.  You need to run revdep-rebuild"
1308                         ewarn "in order to remove these old dependencies.  If you do not have this"
1309                         ewarn "helper program, simply emerge the 'gentoolkit' package."
1310                         ewarn
1311                 fi
1312                 ewarn "  # revdep-rebuild --library '${lib}' && rm '${lib}'"
1313         done
1314 }
1315
1316 # @FUNCTION: built_with_use
1317 # @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1318 # @DESCRIPTION:
1319 #
1320 # Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1321 #
1322 # A temporary hack until portage properly supports DEPENDing on USE
1323 # flags being enabled in packages.  This will check to see if the specified
1324 # DEPEND atom was built with the specified list of USE flags.  The
1325 # --missing option controls the behavior if called on a package that does
1326 # not actually support the defined USE flags (aka listed in IUSE).
1327 # The default is to abort (call die).  The -a and -o flags control
1328 # the requirements of the USE flags.  They correspond to "and" and "or"
1329 # logic.  So the -a flag means all listed USE flags must be enabled
1330 # while the -o flag means at least one of the listed IUSE flags must be
1331 # enabled.  The --hidden option is really for internal use only as it
1332 # means the USE flag we're checking is hidden expanded, so it won't be found
1333 # in IUSE like normal USE flags.
1334 #
1335 # Remember that this function isn't terribly intelligent so order of optional
1336 # flags matter.
1337 built_with_use() {
1338         _eutils_eprefix_init
1339         local hidden="no"
1340         if [[ $1 == "--hidden" ]] ; then
1341                 hidden="yes"
1342                 shift
1343         fi
1344
1345         local missing_action="die"
1346         if [[ $1 == "--missing" ]] ; then
1347                 missing_action=$2
1348                 shift ; shift
1349                 case ${missing_action} in
1350                         true|false|die) ;;
1351                         *) die "unknown action '${missing_action}'";;
1352                 esac
1353         fi
1354
1355         local opt=$1
1356         [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1357
1358         local PKG=$(best_version $1)
1359         [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1360         shift
1361
1362         local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1363         local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1364
1365         # if the IUSE file doesn't exist, the read will error out, we need to handle
1366         # this gracefully
1367         if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1368                 case ${missing_action} in
1369                         true)   return 0;;
1370                         false)  return 1;;
1371                         die)    die "Unable to determine what USE flags $PKG was built with";;
1372                 esac
1373         fi
1374
1375         if [[ ${hidden} == "no" ]] ; then
1376                 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1377                 # Don't check USE_EXPAND #147237
1378                 local expand
1379                 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1380                         if [[ $1 == ${expand}_* ]] ; then
1381                                 expand=""
1382                                 break
1383                         fi
1384                 done
1385                 if [[ -n ${expand} ]] ; then
1386                         if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1387                                 case ${missing_action} in
1388                                         true)  return 0;;
1389                                         false) return 1;;
1390                                         die)   die "$PKG does not actually support the $1 USE flag!";;
1391                                 esac
1392                         fi
1393                 fi
1394         fi
1395
1396         local USE_BUILT=$(<${USEFILE})
1397         while [[ $# -gt 0 ]] ; do
1398                 if [[ ${opt} = "-o" ]] ; then
1399                         has $1 ${USE_BUILT} && return 0
1400                 else
1401                         has $1 ${USE_BUILT} || return 1
1402                 fi
1403                 shift
1404         done
1405         [[ ${opt} = "-a" ]]
1406 }
1407
1408 # If an overlay has eclass overrides, but doesn't actually override the
1409 # libtool.eclass, we'll have ECLASSDIR pointing to the active overlay's
1410 # eclass/ dir, but libtool.eclass is still in the main Gentoo tree.  So
1411 # add a check to locate the ELT-patches/ regardless of what's going on.
1412 # Note: Duplicated in libtool.eclass.
1413 _EUTILS_ECLASSDIR_LOCAL=${BASH_SOURCE[0]%/*}
1414 eutils_elt_patch_dir() {
1415         local d="${ECLASSDIR}/ELT-patches"
1416         if [[ ! -d ${d} ]] ; then
1417                 d="${_EUTILS_ECLASSDIR_LOCAL}/ELT-patches"
1418         fi
1419         echo "${d}"
1420 }
1421
1422 # @FUNCTION: epunt_cxx
1423 # @USAGE: [dir to scan]
1424 # @DESCRIPTION:
1425 # Many configure scripts wrongly bail when a C++ compiler could not be
1426 # detected.  If dir is not specified, then it defaults to ${S}.
1427 #
1428 # https://bugs.gentoo.org/73450
1429 epunt_cxx() {
1430         local dir=$1
1431         [[ -z ${dir} ]] && dir=${S}
1432         ebegin "Removing useless C++ checks"
1433         local f p any_found
1434         while IFS= read -r -d '' f; do
1435                 for p in "$(eutils_elt_patch_dir)"/nocxx/*.patch ; do
1436                         if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1437                                 any_found=1
1438                                 break
1439                         fi
1440                 done
1441         done < <(find "${dir}" -name configure -print0)
1442
1443         if [[ -z ${any_found} ]]; then
1444                 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1445         fi
1446         eend 0
1447 }
1448
1449 # @FUNCTION: make_wrapper
1450 # @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1451 # @DESCRIPTION:
1452 # Create a shell wrapper script named wrapper in installpath
1453 # (defaults to the bindir) to execute target (default of wrapper) by
1454 # first optionally setting LD_LIBRARY_PATH to the colon-delimited
1455 # libpaths followed by optionally changing directory to chdir.
1456 make_wrapper() {
1457         _eutils_eprefix_init
1458         local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1459         local tmpwrapper=$(emktemp)
1460
1461         (
1462         echo '#!/bin/sh'
1463         [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1464         if [[ -n ${libdir} ]] ; then
1465                 local var
1466                 if [[ ${CHOST} == *-darwin* ]] ; then
1467                         var=DYLD_LIBRARY_PATH
1468                 else
1469                         var=LD_LIBRARY_PATH
1470                 fi
1471                 cat <<-EOF
1472                         if [ "\${${var}+set}" = "set" ] ; then
1473                                 export ${var}="\${${var}}:${EPREFIX}${libdir}"
1474                         else
1475                                 export ${var}="${EPREFIX}${libdir}"
1476                         fi
1477                 EOF
1478         fi
1479         # We don't want to quote ${bin} so that people can pass complex
1480         # things as ${bin} ... "./someprog --args"
1481         printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}/}"
1482         ) > "${tmpwrapper}"
1483         chmod go+rx "${tmpwrapper}"
1484
1485         if [[ -n ${path} ]] ; then
1486                 (
1487                 exeinto "${path}"
1488                 newexe "${tmpwrapper}" "${wrapper}"
1489                 ) || die
1490         else
1491                 newbin "${tmpwrapper}" "${wrapper}" || die
1492         fi
1493 }
1494
1495 # @FUNCTION: path_exists
1496 # @USAGE: [-a|-o] <paths>
1497 # @DESCRIPTION:
1498 # Check if the specified paths exist.  Works for all types of paths
1499 # (files/dirs/etc...).  The -a and -o flags control the requirements
1500 # of the paths.  They correspond to "and" and "or" logic.  So the -a
1501 # flag means all the paths must exist while the -o flag means at least
1502 # one of the paths must exist.  The default behavior is "and".  If no
1503 # paths are specified, then the return value is "false".
1504 path_exists() {
1505         local opt=$1
1506         [[ ${opt} == -[ao] ]] && shift || opt="-a"
1507
1508         # no paths -> return false
1509         # same behavior as: [[ -e "" ]]
1510         [[ $# -eq 0 ]] && return 1
1511
1512         local p r=0
1513         for p in "$@" ; do
1514                 [[ -e ${p} ]]
1515                 : $(( r += $? ))
1516         done
1517
1518         case ${opt} in
1519                 -a) return $(( r != 0 )) ;;
1520                 -o) return $(( r == $# )) ;;
1521         esac
1522 }
1523
1524 # @FUNCTION: in_iuse
1525 # @USAGE: <flag>
1526 # @DESCRIPTION:
1527 # Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1528 # as necessary.
1529 #
1530 # Note that this function should not be used in the global scope.
1531 if has "${EAPI:-0}" 0 1 2 3 4 5; then
1532         in_iuse() {
1533                 debug-print-function ${FUNCNAME} "${@}"
1534                 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1535
1536                 local flag=${1}
1537                 local liuse=( ${IUSE} )
1538
1539                 has "${flag}" "${liuse[@]#[+-]}"
1540         }
1541 fi
1542
1543 # @FUNCTION: use_if_iuse
1544 # @USAGE: <flag>
1545 # @DESCRIPTION:
1546 # Return true if the given flag is in USE and IUSE.
1547 #
1548 # Note that this function should not be used in the global scope.
1549 use_if_iuse() {
1550         in_iuse $1 || return 1
1551         use $1
1552 }
1553
1554 # @FUNCTION: usex
1555 # @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1556 # @DESCRIPTION:
1557 # Proxy to declare usex for package managers or EAPIs that do not provide it
1558 # and use the package manager implementation when available (i.e. EAPI >= 5).
1559 # If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1560 # otherwise echo [false output][false suffix] (defaults to "no").
1561 if has "${EAPI:-0}" 0 1 2 3 4; then
1562         usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1563 fi
1564
1565 # @FUNCTION: prune_libtool_files
1566 # @USAGE: [--all|--modules]
1567 # @DESCRIPTION:
1568 # Locate unnecessary libtool files (.la) and libtool static archives
1569 # (.a) and remove them from installation image.
1570 #
1571 # By default, .la files are removed whenever the static linkage can
1572 # either be performed using pkg-config or doesn't introduce additional
1573 # flags.
1574 #
1575 # If '--modules' argument is passed, .la files for modules (plugins) are
1576 # removed as well. This is usually useful when the package installs
1577 # plugins and the plugin loader does not use .la files.
1578 #
1579 # If '--all' argument is passed, all .la files are removed without
1580 # performing any heuristic on them. You shouldn't ever use that,
1581 # and instead report a bug in the algorithm instead.
1582 #
1583 # The .a files are only removed whenever corresponding .la files state
1584 # that they should not be linked to, i.e. whenever these files
1585 # correspond to plugins.
1586 #
1587 # Note: if your package installs both static libraries and .pc files
1588 # which use variable substitution for -l flags, you need to add
1589 # pkg-config to your DEPEND.
1590 prune_libtool_files() {
1591         debug-print-function ${FUNCNAME} "$@"
1592
1593         local removing_all removing_modules opt
1594         _eutils_eprefix_init
1595         for opt; do
1596                 case "${opt}" in
1597                         --all)
1598                                 removing_all=1
1599                                 removing_modules=1
1600                                 ;;
1601                         --modules)
1602                                 removing_modules=1
1603                                 ;;
1604                         *)
1605                                 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1606                 esac
1607         done
1608
1609         local f
1610         local queue=()
1611         while IFS= read -r -d '' f; do # for all .la files
1612                 local archivefile=${f/%.la/.a}
1613
1614                 # The following check is done by libtool itself.
1615                 # It helps us avoid removing random files which match '*.la',
1616                 # see bug #468380.
1617                 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1618                         continue
1619                 fi
1620
1621                 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1622                 local reason= pkgconfig_scanned=
1623                 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1624
1625                 if [[ ${snotlink} == yes ]]; then
1626
1627                         # Remove static libs we're not supposed to link against.
1628                         if [[ -f ${archivefile} ]]; then
1629                                 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1630                                 queue+=( "${archivefile}" )
1631                         fi
1632
1633                         # The .la file may be used by a module loader, so avoid removing it
1634                         # unless explicitly requested.
1635                         if [[ ${removing_modules} ]]; then
1636                                 reason='module'
1637                         fi
1638
1639                 else
1640
1641                         # Remove .la files when:
1642                         # - user explicitly wants us to remove all .la files,
1643                         # - respective static archive doesn't exist,
1644                         # - they are covered by a .pc file already,
1645                         # - they don't provide any new information (no libs & no flags).
1646
1647                         if [[ ${removing_all} ]]; then
1648                                 reason='requested'
1649                         elif [[ ! -f ${archivefile} ]]; then
1650                                 reason='no static archive'
1651                         elif [[ ! $(sed -nre \
1652                                         "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1653                                         "${f}") ]]; then
1654                                 reason='no libs & flags'
1655                         else
1656                                 if [[ ! ${pkgconfig_scanned} ]]; then
1657                                         # Create a list of all .pc-covered libs.
1658                                         local pc_libs=()
1659                                         if [[ ! ${removing_all} ]]; then
1660                                                 local pc
1661                                                 local tf=${T}/prune-lt-files.pc
1662                                                 local pkgconf=$(tc-getPKG_CONFIG)
1663
1664                                                 while IFS= read -r -d '' pc; do # for all .pc files
1665                                                         local arg libs
1666
1667                                                         # Use pkg-config if available (and works),
1668                                                         # fallback to sed.
1669                                                         if ${pkgconf} --exists "${pc}" &>/dev/null; then
1670                                                                 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1671                                                                 libs=$(${pkgconf} --libs "${tf}")
1672                                                         else
1673                                                                 libs=$(sed -ne 's/^Libs://p' "${pc}")
1674                                                         fi
1675
1676                                                         for arg in ${libs}; do
1677                                                                 if [[ ${arg} == -l* ]]; then
1678                                                                         if [[ ${arg} == '*$*' ]]; then
1679                                                                                 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1680                                                                                 eqawarn "(arg: ${arg})"
1681                                                                                 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1682                                                                         fi
1683
1684                                                                         pc_libs+=( lib${arg#-l}.la )
1685                                                                 fi
1686                                                         done
1687                                                 done < <(find "${D}" -type f -name '*.pc' -print0)
1688
1689                                                 rm -f "${tf}"
1690                                         fi
1691
1692                                         pkgconfig_scanned=1
1693                                 fi # pkgconfig_scanned
1694
1695                                 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1696                         fi # removal due to .pc
1697
1698                 fi # shouldnotlink==no
1699
1700                 if [[ ${reason} ]]; then
1701                         einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1702                         queue+=( "${f}" )
1703                 fi
1704         done < <(find "${ED}" -xtype f -name '*.la' -print0)
1705
1706         if [[ ${queue[@]} ]]; then
1707                 rm -f "${queue[@]}"
1708         fi
1709 }
1710
1711 # @FUNCTION: einstalldocs
1712 # @DESCRIPTION:
1713 # Install documentation using DOCS and HTML_DOCS.
1714 #
1715 # If DOCS is declared and non-empty, all files listed in it are
1716 # installed. The files must exist, otherwise the function will fail.
1717 # In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
1718 # in other EAPIs using directories is unsupported.
1719 #
1720 # If DOCS is not declared, the files matching patterns given
1721 # in the default EAPI implementation of src_install will be installed.
1722 # If this is undesired, DOCS can be set to empty value to prevent any
1723 # documentation from being installed.
1724 #
1725 # If HTML_DOCS is declared and non-empty, all files and/or directories
1726 # listed in it are installed as HTML docs (using dohtml).
1727 #
1728 # Both DOCS and HTML_DOCS can either be an array or a whitespace-
1729 # separated list. Whenever directories are allowed, '<directory>/.' may
1730 # be specified in order to install all files within the directory
1731 # without creating a sub-directory in docdir.
1732 #
1733 # Passing additional options to dodoc and dohtml is not supported.
1734 # If you needed such a thing, you need to call those helpers explicitly.
1735 if has "${EAPI:-0}" 0 1 2 3 4 5; then
1736         einstalldocs() {
1737                 debug-print-function ${FUNCNAME} "${@}"
1738
1739                 local dodoc_opts=-r
1740                 has ${EAPI} 0 1 2 3 && dodoc_opts=
1741
1742                 if ! declare -p DOCS &>/dev/null ; then
1743                         local d
1744                         for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1745                                         THANKS BUGS FAQ CREDITS CHANGELOG ; do
1746                                 if [[ -s ${d} ]] ; then
1747                                         dodoc "${d}" || die
1748                                 fi
1749                         done
1750                 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
1751                         if [[ ${DOCS[@]} ]] ; then
1752                                 dodoc ${dodoc_opts} "${DOCS[@]}" || die
1753                         fi
1754                 else
1755                         if [[ ${DOCS} ]] ; then
1756                                 dodoc ${dodoc_opts} ${DOCS} || die
1757                         fi
1758                 fi
1759
1760                 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1761                         if [[ ${HTML_DOCS[@]} ]] ; then
1762                                 dohtml -r "${HTML_DOCS[@]}" || die
1763                         fi
1764                 else
1765                         if [[ ${HTML_DOCS} ]] ; then
1766                                 dohtml -r ${HTML_DOCS} || die
1767                         fi
1768                 fi
1769
1770                 return 0
1771         }
1772 fi
1773
1774 check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1775
1776 # @FUNCTION: optfeature
1777 # @USAGE: <short description> <package atom to match> [other atoms]
1778 # @DESCRIPTION:
1779 # Print out a message suggesting an optional package (or packages) which
1780 # provide the described functionality
1781 #
1782 # The following snippet would suggest app-misc/foo for optional foo support,
1783 # app-misc/bar or app-misc/baz[bar] for optional bar support
1784 # and either both app-misc/a and app-misc/b or app-misc/c for alphabet support.
1785 # @CODE
1786 #       optfeature "foo support" app-misc/foo
1787 #       optfeature "bar support" app-misc/bar app-misc/baz[bar]
1788 #       optfeature "alphabet support" "app-misc/a app-misc/b" app-misc/c
1789 # @CODE
1790 optfeature() {
1791         debug-print-function ${FUNCNAME} "$@"
1792         local i j msg
1793         local desc=$1
1794         local flag=0
1795         shift
1796         for i; do
1797                 for j in ${i}; do
1798                         if has_version "${j}"; then
1799                                 flag=1
1800                         else
1801                                 flag=0
1802                                 break
1803                         fi
1804                 done
1805                 if [[ ${flag} -eq 1 ]]; then
1806                         break
1807                 fi
1808         done
1809         if [[ ${flag} -eq 0 ]]; then
1810                 for i; do
1811                         msg=" "
1812                         for j in ${i}; do
1813                                 msg+=" ${j} and"
1814                         done
1815                         msg="${msg:0: -4} for ${desc}"
1816                         elog "${msg}"
1817                 done
1818         fi
1819 }
1820
1821 fi